﻿#include "SteppingAction.h"
#include "DetectorConstruction.h"
#include "EventAction.h"

#include "G4Event.hh"
#include "G4LogicalVolume.hh"
#include "G4RunManager.hh"
#include "G4Step.hh"

SteppingAction::SteppingAction(EventAction* e) : fEventAction(e) {}

SteppingAction::~SteppingAction() {}

void SteppingAction::UserSteppingAction(const G4Step* step) {
    if (!fScoringVolume) {
        const DetectorConstruction* detConstruction =
            static_cast<const DetectorConstruction*>(G4RunManager::GetRunManager()->GetUserDetectorConstruction());
        fScoringVolume = detConstruction->GetScoringVolume();
    }

    // 获取当前的 Volume
    G4LogicalVolume* volume = step->GetPreStepPoint()->GetTouchableHandle()->GetVolume()->GetLogicalVolume();

    // 检查是否在计算的 Volume （Shape 2）
    if (volume != fScoringVolume) return;

    // 获取当前 step 的沉积能量
    G4double edepStep = step->GetTotalEnergyDeposit();
    fEventAction->AddEdep(edepStep);
}
